---
title: Get monthly usage attribution
description: Datadog, the leading service for cloud-scale monitoring.
breadcrumbs: Docs > API Reference > Usage Metering
---

# Get monthly usage attribution{% #get-monthly-usage-attribution %}
Copy pageCopied
{% tab title="v1" %}

| Datadog site      | API endpoint                                                       |
| ----------------- | ------------------------------------------------------------------ |
| ap1.datadoghq.com | GET https://api.ap1.datadoghq.com/api/v1/usage/monthly-attribution |
| ap2.datadoghq.com | GET https://api.ap2.datadoghq.com/api/v1/usage/monthly-attribution |
| app.datadoghq.eu  | GET https://api.datadoghq.eu/api/v1/usage/monthly-attribution      |
| app.ddog-gov.com  | GET https://api.ddog-gov.com/api/v1/usage/monthly-attribution      |
| us2.ddog-gov.com  | GET https://api.us2.ddog-gov.com/api/v1/usage/monthly-attribution  |
| app.datadoghq.com | GET https://api.datadoghq.com/api/v1/usage/monthly-attribution     |
| us3.datadoghq.com | GET https://api.us3.datadoghq.com/api/v1/usage/monthly-attribution |
| us5.datadoghq.com | GET https://api.us5.datadoghq.com/api/v1/usage/monthly-attribution |

### Overview



Get monthly usage attribution. Multi-region data is available starting March 1, 2023.

This API endpoint is paginated. To make sure you receive all records, check if the value of `next_record_id` is set in the response. If it is, make another request and pass `next_record_id` as a parameter. Pseudo code example:

```
response := GetMonthlyUsageAttribution(start_month)
cursor := response.metadata.pagination.next_record_id
WHILE cursor != null BEGIN
  sleep(5 seconds)  # Avoid running into rate limit
  response := GetMonthlyUsageAttribution(start_month, next_record_id=cursor)
  cursor := response.metadata.pagination.next_record_id
END
```
This endpoint requires the `usage_read` permission.
OAuth apps require the `usage_read` authorization [scope](https://docs.datadoghq.com/api/latest/scopes.md#usage-metering) to access this endpoint.



### Arguments

#### Query Strings

| Name                          | Type    | Description                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                             |
| ----------------------------- | ------- | ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- |
| start_month [*required*] | string  | Datetime in ISO-8601 format, UTC, precise to month: `[YYYY-MM]` for usage beginning in this month. Maximum of 15 months ago.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            |
| end_month                     | string  | Datetime in ISO-8601 format, UTC, precise to month: `[YYYY-MM]` for usage ending this month.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            |
| fields [*required*]      | enum    | Comma-separated list of usage types to return, or `*` for all usage types. Usage types are in the format `<usage_type>_usage` and `<usage_type>_percentage`. Example: `infra_host_usage,infra_host_percentage` To obtain the complete list of usage attribution types that can be used to replace `<usage_type>` in the field names, make a request to the [Get usage attribution types API](https://docs.datadoghq.com/api/latest/usage-metering.md#get-usage-attribution-types). Allowed enum values: `api_usage, api_percentage, apm_fargate_usage, apm_fargate_percentage, appsec_fargate_usage, appsec_fargate_percentage, apm_host_usage, apm_host_percentage, apm_usm_usage, apm_usm_percentage` |
| sort_direction                | enum    | The direction to sort by: `[desc, asc]`. Allowed enum values: `desc, asc`                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                               |
| sort_name                     | enum    | The field to sort by. Sort fields are in the format `<usage_type>_usage`. Example: `infra_host_usage` To obtain the complete list of usage attribution types that can be used to replace `<usage_type>` in the field names, make a request to the [Get usage attribution types API](https://docs.datadoghq.com/api/latest/usage-metering.md#get-usage-attribution-types). Allowed enum values: `api_usage, api_percentage, apm_fargate_usage, apm_fargate_percentage, appsec_fargate_usage, appsec_fargate_percentage, apm_host_usage, apm_host_percentage, apm_usm_usage, apm_usm_percentage`                                                                                                          |
| tag_breakdown_keys            | string  |                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                         |
| next_record_id                | string  | List following results with a next_record_id provided in the previous query.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            |
| include_descendants           | boolean | Include child org usage in the response. Defaults to `true`.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            |

### Response

{% tab title="200" %}
OK
{% tab title="Model" %}
Response containing the monthly Usage Summary by tag(s).

| Parent field         | Field                                               | Type      | Description                                                                                                                                                             |
| -------------------- | --------------------------------------------------- | --------- | ----------------------------------------------------------------------------------------------------------------------------------------------------------------------- |
|                      | metadata                                            | object    | The object containing document metadata.                                                                                                                                |
| metadata             | aggregates                                          | [object]  | An array of available aggregates.                                                                                                                                       |
| aggregates           | agg_type                                            | string    | The aggregate type.                                                                                                                                                     |
| aggregates           | field                                               | string    | The field.                                                                                                                                                              |
| aggregates           | value                                               | double    | The value for a given field.                                                                                                                                            |
| metadata             | pagination                                          | object    | The metadata for the current pagination.                                                                                                                                |
| pagination           | next_record_id                                      | string    | The cursor to use to get the next results, if any. To make the next request, use the same parameters with the addition of the `next_record_id`.                         |
|                      | usage                                               | [object]  | Get usage summary by tag(s).                                                                                                                                            |
| usage                | month                                               | date-time | Datetime in ISO-8601 format, UTC, precise to month: [YYYY-MM].                                                                                                          |
| usage                | org_name                                            | string    | The name of the organization.                                                                                                                                           |
| usage                | public_id                                           | string    | The organization public ID.                                                                                                                                             |
| usage                | region                                              | string    | The region of the Datadog instance that the organization belongs to.                                                                                                    |
| usage                | tag_config_source                                   | string    | The source of the usage attribution tag configuration and the selected tags in the format `<source_org_name>:::<selected tag 1>///<selected tag 2>///<selected tag 3>`. |
| usage                | tags                                                | object    | Tag keys and values.                                                                                                                                                    | A `null` value here means that the requested tag breakdown cannot be applied because it does not match the [tags configured for usage attribution](https://docs.datadoghq.com/account_management/billing/usage_attribution.md#getting-started). In this scenario the API returns the total usage, not broken down by tags. |
| additionalProperties | <any-key>                                           | [string]  | A list of values that are associated with each tag key.                                                                                                                 |
| usage                | updated_at                                          | date-time | Datetime of the most recent update to the usage values.                                                                                                                 |
| usage                | values                                              | object    | Fields in Usage Summary by tag(s).                                                                                                                                      |
| values               | api_percentage                                      | double    | The percentage of synthetic API test usage by tag(s).                                                                                                                   |
| values               | api_usage                                           | double    | The synthetic API test usage by tag(s).                                                                                                                                 |
| values               | apm_fargate_percentage                              | double    | The percentage of APM ECS Fargate task usage by tag(s).                                                                                                                 |
| values               | apm_fargate_usage                                   | double    | The APM ECS Fargate task usage by tag(s).                                                                                                                               |
| values               | apm_host_percentage                                 | double    | The percentage of APM host usage by tag(s).                                                                                                                             |
| values               | apm_host_usage                                      | double    | The APM host usage by tag(s).                                                                                                                                           |
| values               | apm_usm_percentage                                  | double    | The percentage of APM and Universal Service Monitoring host usage by tag(s).                                                                                            |
| values               | apm_usm_usage                                       | double    | The APM and Universal Service Monitoring host usage by tag(s).                                                                                                          |
| values               | appsec_fargate_percentage                           | double    | The percentage of Application Security Monitoring ECS Fargate task usage by tag(s).                                                                                     |
| values               | appsec_fargate_usage                                | double    | The Application Security Monitoring ECS Fargate task usage by tag(s).                                                                                                   |
| values               | appsec_percentage                                   | double    | The percentage of Application Security Monitoring host usage by tag(s).                                                                                                 |
| values               | appsec_usage                                        | double    | The Application Security Monitoring host usage by tag(s).                                                                                                               |
| values               | asm_serverless_traced_invocations_percentage        | double    | The percentage of Application Security Monitoring Serverless traced invocations usage by tag(s).                                                                        |
| values               | asm_serverless_traced_invocations_usage             | double    | The Application Security Monitoring Serverless traced invocations usage by tag(s).                                                                                      |
| values               | bits_ai_investigations_percentage                   | double    | The percentage of Bits AI `SRE` investigation usage by tag(s).                                                                                                          |
| values               | bits_ai_investigations_usage                        | double    | The Bits AI `SRE` investigation usage by tag(s).                                                                                                                        |
| values               | browser_percentage                                  | double    | The percentage of synthetic browser test usage by tag(s).                                                                                                               |
| values               | browser_usage                                       | double    | The synthetic browser test usage by tag(s).                                                                                                                             |
| values               | ci_code_coverage_committers_percentage              | double    | The percentage of Code Coverage committers usage by tag(s).                                                                                                             |
| values               | ci_code_coverage_committers_usage                   | double    | The total Code Coverage committers usage by tag(s).                                                                                                                     |
| values               | ci_pipeline_indexed_spans_percentage                | double    | The percentage of CI Pipeline Indexed Spans usage by tag(s).                                                                                                            |
| values               | ci_pipeline_indexed_spans_usage                     | double    | The total CI Pipeline Indexed Spans usage by tag(s).                                                                                                                    |
| values               | ci_test_indexed_spans_percentage                    | double    | The percentage of CI Test Indexed Spans usage by tag(s).                                                                                                                |
| values               | ci_test_indexed_spans_usage                         | double    | The total CI Test Indexed Spans usage by tag(s).                                                                                                                        |
| values               | ci_visibility_itr_percentage                        | double    | The percentage of Git committers for Intelligent Test Runner usage by tag(s).                                                                                           |
| values               | ci_visibility_itr_usage                             | double    | The Git committers for Intelligent Test Runner usage by tag(s).                                                                                                         |
| values               | cloud_siem_percentage                               | double    | The percentage of Cloud Security Information and Event Management usage by tag(s).                                                                                      |
| values               | cloud_siem_usage                                    | double    | The Cloud Security Information and Event Management usage by tag(s).                                                                                                    |
| values               | code_security_host_percentage                       | double    | The percentage of Code Security host usage by tags.                                                                                                                     |
| values               | code_security_host_usage                            | double    | The Code Security host usage by tags.                                                                                                                                   |
| values               | container_excl_agent_percentage                     | double    | The percentage of container usage without the Datadog Agent by tag(s).                                                                                                  |
| values               | container_excl_agent_usage                          | double    | The container usage without the Datadog Agent by tag(s).                                                                                                                |
| values               | container_percentage                                | double    | The percentage of container usage by tag(s).                                                                                                                            |
| values               | container_usage                                     | double    | The container usage by tag(s).                                                                                                                                          |
| values               | cspm_containers_percentage                          | double    | The percentage of Cloud Security Management Pro container usage by tag(s).                                                                                              |
| values               | cspm_containers_usage                               | double    | The Cloud Security Management Pro container usage by tag(s).                                                                                                            |
| values               | cspm_hosts_percentage                               | double    | The percentage of Cloud Security Management Pro host usage by tag(s).                                                                                                   |
| values               | cspm_hosts_usage                                    | double    | The Cloud Security Management Pro host usage by tag(s).                                                                                                                 |
| values               | custom_event_percentage                             | double    | The percentage of Custom Events usage by tag(s).                                                                                                                        |
| values               | custom_event_usage                                  | double    | The total Custom Events usage by tag(s).                                                                                                                                |
| values               | custom_ingested_timeseries_percentage               | double    | The percentage of ingested custom metrics usage by tag(s).                                                                                                              |
| values               | custom_ingested_timeseries_usage                    | double    | The ingested custom metrics usage by tag(s).                                                                                                                            |
| values               | custom_timeseries_percentage                        | double    | The percentage of indexed custom metrics usage by tag(s).                                                                                                               |
| values               | custom_timeseries_usage                             | double    | The indexed custom metrics usage by tag(s).                                                                                                                             |
| values               | cws_containers_percentage                           | double    | The percentage of Cloud Workload Security container usage by tag(s).                                                                                                    |
| values               | cws_containers_usage                                | double    | The Cloud Workload Security container usage by tag(s).                                                                                                                  |
| values               | cws_fargate_task_percentage                         | double    | The percentage of Cloud Workload Security Fargate task usage by tag(s).                                                                                                 |
| values               | cws_fargate_task_usage                              | double    | The Cloud Workload Security Fargate task usage by tag(s).                                                                                                               |
| values               | cws_hosts_percentage                                | double    | The percentage of Cloud Workload Security host usage by tag(s).                                                                                                         |
| values               | cws_hosts_usage                                     | double    | The Cloud Workload Security host usage by tag(s).                                                                                                                       |
| values               | data_jobs_monitoring_usage                          | double    | The Data Jobs Monitoring usage by tag(s).                                                                                                                               |
| values               | data_stream_monitoring_usage                        | double    | The Data Stream Monitoring usage by tag(s).                                                                                                                             |
| values               | dbm_hosts_percentage                                | double    | The percentage of Database Monitoring host usage by tag(s).                                                                                                             |
| values               | dbm_hosts_usage                                     | double    | The Database Monitoring host usage by tag(s).                                                                                                                           |
| values               | dbm_queries_percentage                              | double    | The percentage of Database Monitoring queries usage by tag(s).                                                                                                          |
| values               | dbm_queries_usage                                   | double    | The Database Monitoring queries usage by tag(s).                                                                                                                        |
| values               | error_tracking_percentage                           | double    | The percentage of error tracking events usage by tag(s).                                                                                                                |
| values               | error_tracking_usage                                | double    | The error tracking events usage by tag(s).                                                                                                                              |
| values               | estimated_indexed_spans_percentage                  | double    | The percentage of estimated indexed spans usage by tag(s).                                                                                                              |
| values               | estimated_indexed_spans_usage                       | double    | The estimated indexed spans usage by tag(s).                                                                                                                            |
| values               | estimated_ingested_spans_percentage                 | double    | The percentage of estimated ingested spans usage by tag(s).                                                                                                             |
| values               | estimated_ingested_spans_usage                      | double    | The estimated ingested spans usage by tag(s).                                                                                                                           |
| values               | fargate_percentage                                  | double    | The percentage of Fargate usage by tags.                                                                                                                                |
| values               | fargate_usage                                       | double    | The Fargate usage by tags.                                                                                                                                              |
| values               | flex_logs_starter_percentage                        | double    | The percentage of Flex Logs Starter usage by tags.                                                                                                                      |
| values               | flex_logs_starter_usage                             | double    | The Flex Logs Starter usage by tags.                                                                                                                                    |
| values               | flex_stored_logs_percentage                         | double    | The percentage of Flex Stored Logs usage by tags.                                                                                                                       |
| values               | flex_stored_logs_usage                              | double    | The Flex Stored Logs usage by tags.                                                                                                                                     |
| values               | functions_percentage                                | double    | The percentage of Lambda function usage by tag(s).                                                                                                                      |
| values               | functions_usage                                     | double    | The Lambda function usage by tag(s).                                                                                                                                    |
| values               | incident_management_monthly_active_users_percentage | double    | The percentage of Incident Management monthly active users usage by tag(s).                                                                                             |
| values               | incident_management_monthly_active_users_usage      | double    | The Incident Management monthly active users usage by tag(s).                                                                                                           |
| values               | indexed_spans_percentage                            | double    | The percentage of APM Indexed Spans usage by tag(s).                                                                                                                    |
| values               | indexed_spans_usage                                 | double    | The total APM Indexed Spans usage by tag(s).                                                                                                                            |
| values               | infra_host_basic_percentage                         | double    | The percentage of infrastructure host Basic tier usage by tag(s).                                                                                                       |
| values               | infra_host_basic_usage                              | double    | The infrastructure host Basic tier usage by tag(s).                                                                                                                     |
| values               | infra_host_percentage                               | double    | The percentage of infrastructure host usage by tag(s).                                                                                                                  |
| values               | infra_host_usage                                    | double    | The infrastructure host usage by tag(s).                                                                                                                                |
| values               | ingested_logs_bytes_percentage                      | double    | The percentage of Ingested Logs usage by tag(s).                                                                                                                        |
| values               | ingested_logs_bytes_usage                           | double    | The total Ingested Logs usage by tag(s).                                                                                                                                |
| values               | ingested_spans_bytes_percentage                     | double    | The percentage of APM Ingested Spans usage by tag(s).                                                                                                                   |
| values               | ingested_spans_bytes_usage                          | double    | The total APM Ingested Spans usage by tag(s).                                                                                                                           |
| values               | invocations_percentage                              | double    | The percentage of Lambda invocation usage by tag(s).                                                                                                                    |
| values               | invocations_usage                                   | double    | The Lambda invocation usage by tag(s).                                                                                                                                  |
| values               | lambda_traced_invocations_percentage                | double    | The percentage of Serverless APM usage by tag(s).                                                                                                                       |
| values               | lambda_traced_invocations_usage                     | double    | The Serverless APM usage by tag(s).                                                                                                                                     |
| values               | llm_observability_percentage                        | double    | The percentage of LLM Observability usage by tag(s).                                                                                                                    |
| values               | llm_observability_usage                             | double    | The LLM Observability usage by tag(s).                                                                                                                                  |
| values               | llm_spans_percentage                                | double    | The percentage of LLM Spans usage by tag(s).                                                                                                                            |
| values               | llm_spans_usage                                     | double    | The LLM Spans usage by tag(s).                                                                                                                                          |
| values               | logs_indexed_15day_percentage                       | double    | The percentage of Indexed Logs (15-day Retention) usage by tag(s).                                                                                                      |
| values               | logs_indexed_15day_usage                            | double    | The total Indexed Logs (15-day Retention) usage by tag(s).                                                                                                              |
| values               | logs_indexed_180day_percentage                      | double    | The percentage of Indexed Logs (180-day Retention) usage by tag(s).                                                                                                     |
| values               | logs_indexed_180day_usage                           | double    | The total Indexed Logs (180-day Retention) usage by tag(s).                                                                                                             |
| values               | logs_indexed_1day_percentage                        | double    | The percentage of Indexed Logs (1-day Retention) usage by tag(s).                                                                                                       |
| values               | logs_indexed_1day_usage                             | double    | The total Indexed Logs (1-day Retention) usage by tag(s).                                                                                                               |
| values               | logs_indexed_30day_percentage                       | double    | The percentage of Indexed Logs (30-day Retention) usage by tag(s).                                                                                                      |
| values               | logs_indexed_30day_usage                            | double    | The total Indexed Logs (30-day Retention) usage by tag(s).                                                                                                              |
| values               | logs_indexed_360day_percentage                      | double    | The percentage of Indexed Logs (360-day Retention) usage by tag(s).                                                                                                     |
| values               | logs_indexed_360day_usage                           | double    | The total Indexed Logs (360-day Retention) usage by tag(s).                                                                                                             |
| values               | logs_indexed_3day_percentage                        | double    | The percentage of Indexed Logs (3-day Retention) usage by tag(s).                                                                                                       |
| values               | logs_indexed_3day_usage                             | double    | The total Indexed Logs (3-day Retention) usage by tag(s).                                                                                                               |
| values               | logs_indexed_45day_percentage                       | double    | The percentage of Indexed Logs (45-day Retention) usage by tag(s).                                                                                                      |
| values               | logs_indexed_45day_usage                            | double    | The total Indexed Logs (45-day Retention) usage by tag(s).                                                                                                              |
| values               | logs_indexed_60day_percentage                       | double    | The percentage of Indexed Logs (60-day Retention) usage by tag(s).                                                                                                      |
| values               | logs_indexed_60day_usage                            | double    | The total Indexed Logs (60-day Retention) usage by tag(s).                                                                                                              |
| values               | logs_indexed_7day_percentage                        | double    | The percentage of Indexed Logs (7-day Retention) usage by tag(s).                                                                                                       |
| values               | logs_indexed_7day_usage                             | double    | The total Indexed Logs (7-day Retention) usage by tag(s).                                                                                                               |
| values               | logs_indexed_90day_percentage                       | double    | The percentage of Indexed Logs (90-day Retention) usage by tag(s).                                                                                                      |
| values               | logs_indexed_90day_usage                            | double    | The total Indexed Logs (90-day Retention) usage by tag(s).                                                                                                              |
| values               | logs_indexed_custom_retention_percentage            | double    | The percentage of Indexed Logs (Custom Retention) usage by tag(s).                                                                                                      |
| values               | logs_indexed_custom_retention_usage                 | double    | The total Indexed Logs (Custom Retention) usage by tag(s).                                                                                                              |
| values               | mobile_app_testing_percentage                       | double    | The percentage of Synthetic mobile application test usage by tag(s).                                                                                                    |
| values               | mobile_app_testing_usage                            | double    | The Synthetic mobile application test usage by tag(s).                                                                                                                  |
| values               | ndm_netflow_percentage                              | double    | The percentage of Network Device Monitoring NetFlow usage by tag(s).                                                                                                    |
| values               | ndm_netflow_usage                                   | double    | The Network Device Monitoring NetFlow usage by tag(s).                                                                                                                  |
| values               | network_device_wireless_percentage                  | double    | The percentage of network device wireless usage by tag(s).                                                                                                              |
| values               | network_device_wireless_usage                       | double    | The network device wireless usage by tag(s).                                                                                                                            |
| values               | npm_host_percentage                                 | double    | The percentage of network host usage by tag(s).                                                                                                                         |
| values               | npm_host_usage                                      | double    | The network host usage by tag(s).                                                                                                                                       |
| values               | obs_pipeline_bytes_percentage                       | double    | The percentage of observability pipeline bytes usage by tag(s).                                                                                                         |
| values               | obs_pipeline_bytes_usage                            | double    | The observability pipeline bytes usage by tag(s).                                                                                                                       |
| values               | obs_pipelines_vcpu_percentage                       | double    | The percentage of observability pipeline per core usage by tag(s).                                                                                                      |
| values               | obs_pipelines_vcpu_usage                            | double    | The observability pipeline per core usage by tag(s).                                                                                                                    |
| values               | online_archive_percentage                           | double    | The percentage of online archive usage by tag(s).                                                                                                                       |
| values               | online_archive_usage                                | double    | The online archive usage by tag(s).                                                                                                                                     |
| values               | product_analytics_session_percentage                | double    | The percentage of Product Analytics session usage by tag(s).                                                                                                            |
| values               | product_analytics_session_usage                     | double    | The Product Analytics session usage by tag(s).                                                                                                                          |
| values               | profiled_container_percentage                       | double    | The percentage of profiled container usage by tag(s).                                                                                                                   |
| values               | profiled_container_usage                            | double    | The profiled container usage by tag(s).                                                                                                                                 |
| values               | profiled_fargate_percentage                         | double    | The percentage of profiled Fargate task usage by tag(s).                                                                                                                |
| values               | profiled_fargate_usage                              | double    | The profiled Fargate task usage by tag(s).                                                                                                                              |
| values               | profiled_host_percentage                            | double    | The percentage of profiled hosts usage by tag(s).                                                                                                                       |
| values               | profiled_host_usage                                 | double    | The profiled hosts usage by tag(s).                                                                                                                                     |
| values               | published_app_percentage                            | double    | The percentage of published application usage by tag(s).                                                                                                                |
| values               | published_app_usage                                 | double    | The published application usage by tag(s).                                                                                                                              |
| values               | rum_browser_mobile_sessions_percentage              | double    | The percentage of RUM Browser and Mobile usage by tag(s).                                                                                                               |
| values               | rum_browser_mobile_sessions_usage                   | double    | The total RUM Browser and Mobile usage by tag(s).                                                                                                                       |
| values               | rum_ingested_percentage                             | double    | The percentage of RUM Ingested usage by tag(s).                                                                                                                         |
| values               | rum_ingested_usage                                  | double    | The total RUM Ingested usage by tag(s).                                                                                                                                 |
| values               | rum_investigate_percentage                          | double    | The percentage of RUM Investigate usage by tag(s).                                                                                                                      |
| values               | rum_investigate_usage                               | double    | The total RUM Investigate usage by tag(s).                                                                                                                              |
| values               | rum_replay_sessions_percentage                      | double    | The percentage of RUM Session Replay usage by tag(s).                                                                                                                   |
| values               | rum_replay_sessions_usage                           | double    | The total RUM Session Replay usage by tag(s).                                                                                                                           |
| values               | rum_session_replay_add_on_percentage                | double    | The percentage of RUM Session Replay Add-On usage by tag(s).                                                                                                            |
| values               | rum_session_replay_add_on_usage                     | double    | The total RUM Session Replay Add-On usage by tag(s).                                                                                                                    |
| values               | sca_fargate_percentage                              | double    | The percentage of Software Composition Analysis Fargate task usage by tag(s).                                                                                           |
| values               | sca_fargate_usage                                   | double    | The total Software Composition Analysis Fargate task usage by tag(s).                                                                                                   |
| values               | sds_scanned_bytes_percentage                        | double    | The percentage of Sensitive Data Scanner usage by tag(s).                                                                                                               |
| values               | sds_scanned_bytes_usage                             | double    | The total Sensitive Data Scanner usage by tag(s).                                                                                                                       |
| values               | serverless_apps_apm_percentage                      | double    | The percentage of Serverless Apps APM usage by tag(s).                                                                                                                  |
| values               | serverless_apps_apm_usage                           | double    | The total Serverless Apps APM usage by tag(s).                                                                                                                          |
| values               | serverless_apps_percentage                          | double    | The percentage of Serverless Apps usage by tag(s).                                                                                                                      |
| values               | serverless_apps_usage                               | double    | The total Serverless Apps usage by tag(s).                                                                                                                              |
| values               | siem_12mo_retention_percentage                      | double    | The percentage of Cloud SIEM Indexed Logs (12-month retention) usage by tag(s).                                                                                         |
| values               | siem_12mo_retention_usage                           | double    | The Cloud SIEM Indexed Logs (12-month retention) usage by tag(s).                                                                                                       |
| values               | siem_6mo_retention_percentage                       | double    | The percentage of Cloud SIEM Indexed Logs (6-month retention) usage by tag(s).                                                                                          |
| values               | siem_6mo_retention_usage                            | double    | The Cloud SIEM Indexed Logs (6-month retention) usage by tag(s).                                                                                                        |
| values               | siem_analyzed_logs_add_on_percentage                | double    | The percentage of log events analyzed by Cloud SIEM usage by tag(s).                                                                                                    |
| values               | siem_analyzed_logs_add_on_usage                     | double    | The log events analyzed by Cloud SIEM usage by tag(s).                                                                                                                  |
| values               | siem_ingested_bytes_percentage                      | double    | The percentage of SIEM usage by tag(s).                                                                                                                                 |
| values               | siem_ingested_bytes_usage                           | double    | The total SIEM usage by tag(s).                                                                                                                                         |
| values               | snmp_percentage                                     | double    | The percentage of network device usage by tag(s).                                                                                                                       |
| values               | snmp_usage                                          | double    | The network device usage by tag(s).                                                                                                                                     |
| values               | universal_service_monitoring_percentage             | double    | The percentage of universal service monitoring usage by tag(s).                                                                                                         |
| values               | universal_service_monitoring_usage                  | double    | The universal service monitoring usage by tag(s).                                                                                                                       |
| values               | vuln_management_hosts_percentage                    | double    | The percentage of Application Vulnerability Management usage by tag(s).                                                                                                 |
| values               | vuln_management_hosts_usage                         | double    | The Application Vulnerability Management usage by tag(s).                                                                                                               |
| values               | workflow_executions_percentage                      | double    | The percentage of workflow executions usage by tag(s).                                                                                                                  |
| values               | workflow_executions_usage                           | double    | The total workflow executions usage by tag(s).                                                                                                                          |

{% /tab %}

{% tab title="Example" %}

```json
{
  "metadata": {
    "aggregates": [
      {
        "agg_type": "sum",
        "field": "custom_timeseries_usage",
        "value": "number"
      }
    ],
    "pagination": {
      "next_record_id": "string"
    }
  },
  "usage": [
    {
      "month": "2019-09-19T10:00:00.000Z",
      "org_name": "string",
      "public_id": "string",
      "region": "string",
      "tag_config_source": "string",
      "tags": {
        "<any-key>": [
          "datadog-integrations-lab"
        ]
      },
      "updated_at": "2019-09-19T10:00:00.000Z",
      "values": {
        "api_percentage": "number",
        "api_usage": "number",
        "apm_fargate_percentage": "number",
        "apm_fargate_usage": "number",
        "apm_host_percentage": "number",
        "apm_host_usage": "number",
        "apm_usm_percentage": "number",
        "apm_usm_usage": "number",
        "appsec_fargate_percentage": "number",
        "appsec_fargate_usage": "number",
        "appsec_percentage": "number",
        "appsec_usage": "number",
        "asm_serverless_traced_invocations_percentage": "number",
        "asm_serverless_traced_invocations_usage": "number",
        "bits_ai_investigations_percentage": "number",
        "bits_ai_investigations_usage": "number",
        "browser_percentage": "number",
        "browser_usage": "number",
        "ci_code_coverage_committers_percentage": "number",
        "ci_code_coverage_committers_usage": "number",
        "ci_pipeline_indexed_spans_percentage": "number",
        "ci_pipeline_indexed_spans_usage": "number",
        "ci_test_indexed_spans_percentage": "number",
        "ci_test_indexed_spans_usage": "number",
        "ci_visibility_itr_percentage": "number",
        "ci_visibility_itr_usage": "number",
        "cloud_siem_percentage": "number",
        "cloud_siem_usage": "number",
        "code_security_host_percentage": "number",
        "code_security_host_usage": "number",
        "container_excl_agent_percentage": "number",
        "container_excl_agent_usage": "number",
        "container_percentage": "number",
        "container_usage": "number",
        "cspm_containers_percentage": "number",
        "cspm_containers_usage": "number",
        "cspm_hosts_percentage": "number",
        "cspm_hosts_usage": "number",
        "custom_event_percentage": "number",
        "custom_event_usage": "number",
        "custom_ingested_timeseries_percentage": "number",
        "custom_ingested_timeseries_usage": "number",
        "custom_timeseries_percentage": "number",
        "custom_timeseries_usage": "number",
        "cws_containers_percentage": "number",
        "cws_containers_usage": "number",
        "cws_fargate_task_percentage": "number",
        "cws_fargate_task_usage": "number",
        "cws_hosts_percentage": "number",
        "cws_hosts_usage": "number",
        "data_jobs_monitoring_usage": "number",
        "data_stream_monitoring_usage": "number",
        "dbm_hosts_percentage": "number",
        "dbm_hosts_usage": "number",
        "dbm_queries_percentage": "number",
        "dbm_queries_usage": "number",
        "error_tracking_percentage": "number",
        "error_tracking_usage": "number",
        "estimated_indexed_spans_percentage": "number",
        "estimated_indexed_spans_usage": "number",
        "estimated_ingested_spans_percentage": "number",
        "estimated_ingested_spans_usage": "number",
        "fargate_percentage": "number",
        "fargate_usage": "number",
        "flex_logs_starter_percentage": "number",
        "flex_logs_starter_usage": "number",
        "flex_stored_logs_percentage": "number",
        "flex_stored_logs_usage": "number",
        "functions_percentage": "number",
        "functions_usage": "number",
        "incident_management_monthly_active_users_percentage": "number",
        "incident_management_monthly_active_users_usage": "number",
        "indexed_spans_percentage": "number",
        "indexed_spans_usage": "number",
        "infra_host_basic_percentage": "number",
        "infra_host_basic_usage": "number",
        "infra_host_percentage": "number",
        "infra_host_usage": "number",
        "ingested_logs_bytes_percentage": "number",
        "ingested_logs_bytes_usage": "number",
        "ingested_spans_bytes_percentage": "number",
        "ingested_spans_bytes_usage": "number",
        "invocations_percentage": "number",
        "invocations_usage": "number",
        "lambda_traced_invocations_percentage": "number",
        "lambda_traced_invocations_usage": "number",
        "llm_observability_percentage": "number",
        "llm_observability_usage": "number",
        "llm_spans_percentage": "number",
        "llm_spans_usage": "number",
        "logs_indexed_15day_percentage": "number",
        "logs_indexed_15day_usage": "number",
        "logs_indexed_180day_percentage": "number",
        "logs_indexed_180day_usage": "number",
        "logs_indexed_1day_percentage": "number",
        "logs_indexed_1day_usage": "number",
        "logs_indexed_30day_percentage": "number",
        "logs_indexed_30day_usage": "number",
        "logs_indexed_360day_percentage": "number",
        "logs_indexed_360day_usage": "number",
        "logs_indexed_3day_percentage": "number",
        "logs_indexed_3day_usage": "number",
        "logs_indexed_45day_percentage": "number",
        "logs_indexed_45day_usage": "number",
        "logs_indexed_60day_percentage": "number",
        "logs_indexed_60day_usage": "number",
        "logs_indexed_7day_percentage": "number",
        "logs_indexed_7day_usage": "number",
        "logs_indexed_90day_percentage": "number",
        "logs_indexed_90day_usage": "number",
        "logs_indexed_custom_retention_percentage": "number",
        "logs_indexed_custom_retention_usage": "number",
        "mobile_app_testing_percentage": "number",
        "mobile_app_testing_usage": "number",
        "ndm_netflow_percentage": "number",
        "ndm_netflow_usage": "number",
        "network_device_wireless_percentage": "number",
        "network_device_wireless_usage": "number",
        "npm_host_percentage": "number",
        "npm_host_usage": "number",
        "obs_pipeline_bytes_percentage": "number",
        "obs_pipeline_bytes_usage": "number",
        "obs_pipelines_vcpu_percentage": "number",
        "obs_pipelines_vcpu_usage": "number",
        "online_archive_percentage": "number",
        "online_archive_usage": "number",
        "product_analytics_session_percentage": "number",
        "product_analytics_session_usage": "number",
        "profiled_container_percentage": "number",
        "profiled_container_usage": "number",
        "profiled_fargate_percentage": "number",
        "profiled_fargate_usage": "number",
        "profiled_host_percentage": "number",
        "profiled_host_usage": "number",
        "published_app_percentage": "number",
        "published_app_usage": "number",
        "rum_browser_mobile_sessions_percentage": "number",
        "rum_browser_mobile_sessions_usage": "number",
        "rum_ingested_percentage": "number",
        "rum_ingested_usage": "number",
        "rum_investigate_percentage": "number",
        "rum_investigate_usage": "number",
        "rum_replay_sessions_percentage": "number",
        "rum_replay_sessions_usage": "number",
        "rum_session_replay_add_on_percentage": "number",
        "rum_session_replay_add_on_usage": "number",
        "sca_fargate_percentage": "number",
        "sca_fargate_usage": "number",
        "sds_scanned_bytes_percentage": "number",
        "sds_scanned_bytes_usage": "number",
        "serverless_apps_apm_percentage": "number",
        "serverless_apps_apm_usage": "number",
        "serverless_apps_percentage": "number",
        "serverless_apps_usage": "number",
        "siem_12mo_retention_percentage": "number",
        "siem_12mo_retention_usage": "number",
        "siem_6mo_retention_percentage": "number",
        "siem_6mo_retention_usage": "number",
        "siem_analyzed_logs_add_on_percentage": "number",
        "siem_analyzed_logs_add_on_usage": "number",
        "siem_ingested_bytes_percentage": "number",
        "siem_ingested_bytes_usage": "number",
        "snmp_percentage": "number",
        "snmp_usage": "number",
        "universal_service_monitoring_percentage": "number",
        "universal_service_monitoring_usage": "number",
        "vuln_management_hosts_percentage": "number",
        "vuln_management_hosts_usage": "number",
        "workflow_executions_percentage": "number",
        "workflow_executions_usage": "number"
      }
    }
  ]
}
```

{% /tab %}

{% /tab %}

{% tab title="403" %}
Forbidden - User is not authorized
{% tab title="Model" %}
Error response object.

| Field                    | Type     | Description                          |
| ------------------------ | -------- | ------------------------------------ |
| errors [*required*] | [string] | Array of errors returned by the API. |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    "Bad Request"
  ]
}
```

{% /tab %}

{% /tab %}

{% tab title="429" %}
Too many requests
{% tab title="Model" %}
Error response object.

| Field                    | Type     | Description                          |
| ------------------------ | -------- | ------------------------------------ |
| errors [*required*] | [string] | Array of errors returned by the API. |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    "Bad Request"
  ]
}
```

{% /tab %}

{% /tab %}

### Code Example

##### 
                  \# Required query arguments export start_month="CHANGE_ME" export fields="CHANGE_ME" \# Curl command curl -X GET "https://api.datadoghq.com/api/v1/usage/monthly-attribution?start_month=${start_month}&fields=${fields}" \
-H "Accept: application/json" \
-H "DD-API-KEY: ${DD_API_KEY}" \
-H "DD-APPLICATION-KEY: ${DD_APP_KEY}" 
                
##### 

```python
"""
Get monthly usage attribution returns "OK" response
"""

from datetime import datetime
from dateutil.relativedelta import relativedelta
from datadog_api_client import ApiClient, Configuration
from datadog_api_client.v1.api.usage_metering_api import UsageMeteringApi
from datadog_api_client.v1.model.monthly_usage_attribution_supported_metrics import (
    MonthlyUsageAttributionSupportedMetrics,
)

configuration = Configuration()
with ApiClient(configuration) as api_client:
    api_instance = UsageMeteringApi(api_client)
    response = api_instance.get_monthly_usage_attribution(
        start_month=(datetime.now() + relativedelta(days=-3)),
        fields=MonthlyUsageAttributionSupportedMetrics.INFRA_HOST_USAGE,
    )

    print(response)
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=python) and then save the example to `example.py` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" python3 "example.py"
##### 

```ruby
# Get monthly usage attribution returns "OK" response

require "datadog_api_client"
api_instance = DatadogAPIClient::V1::UsageMeteringAPI.new
p api_instance.get_monthly_usage_attribution((Time.now + -3 * 86400), MonthlyUsageAttributionSupportedMetrics::INFRA_HOST_USAGE)
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=ruby) and then save the example to `example.rb` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" rb "example.rb"
##### 

```go
// Get monthly usage attribution returns "OK" response

package main

import (
	"context"
	"encoding/json"
	"fmt"
	"os"
	"time"

	"github.com/DataDog/datadog-api-client-go/v2/api/datadog"
	"github.com/DataDog/datadog-api-client-go/v2/api/datadogV1"
)

func main() {
	ctx := datadog.NewDefaultContext(context.Background())
	configuration := datadog.NewConfiguration()
	apiClient := datadog.NewAPIClient(configuration)
	api := datadogV1.NewUsageMeteringApi(apiClient)
	resp, r, err := api.GetMonthlyUsageAttribution(ctx, time.Now().AddDate(0, 0, -3), datadogV1.MONTHLYUSAGEATTRIBUTIONSUPPORTEDMETRICS_INFRA_HOST_USAGE, *datadogV1.NewGetMonthlyUsageAttributionOptionalParameters())

	if err != nil {
		fmt.Fprintf(os.Stderr, "Error when calling `UsageMeteringApi.GetMonthlyUsageAttribution`: %v\n", err)
		fmt.Fprintf(os.Stderr, "Full HTTP response: %v\n", r)
	}

	responseContent, _ := json.MarshalIndent(resp, "", "  ")
	fmt.Fprintf(os.Stdout, "Response from `UsageMeteringApi.GetMonthlyUsageAttribution`:\n%s\n", responseContent)
}
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=go) and then save the example to `main.go` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" go run "main.go"
##### 

```java
// Get monthly usage attribution returns "OK" response
import com.datadog.api.client.ApiClient;
import com.datadog.api.client.ApiException;
import com.datadog.api.client.v1.api.UsageMeteringApi;
import com.datadog.api.client.v1.model.MonthlyUsageAttributionResponse;
import com.datadog.api.client.v1.model.MonthlyUsageAttributionSupportedMetrics;
import java.time.OffsetDateTime;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = ApiClient.getDefaultApiClient();
    UsageMeteringApi apiInstance = new UsageMeteringApi(defaultClient);

    try {
      MonthlyUsageAttributionResponse result =
          apiInstance.getMonthlyUsageAttribution(
              OffsetDateTime.now().plusDays(-3),
              MonthlyUsageAttributionSupportedMetrics.INFRA_HOST_USAGE);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling UsageMeteringApi#getMonthlyUsageAttribution");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=java) and then save the example to `Example.java` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" java "Example.java"
##### 

```rust
// Get monthly usage attribution returns "OK" response
use chrono::{DateTime, Utc};
use datadog_api_client::datadog;
use datadog_api_client::datadogV1::api_usage_metering::GetMonthlyUsageAttributionOptionalParams;
use datadog_api_client::datadogV1::api_usage_metering::UsageMeteringAPI;
use datadog_api_client::datadogV1::model::MonthlyUsageAttributionSupportedMetrics;

#[tokio::main]
async fn main() {
    let configuration = datadog::Configuration::new();
    let api = UsageMeteringAPI::with_config(configuration);
    let resp = api
        .get_monthly_usage_attribution(
            DateTime::parse_from_rfc3339("2021-11-08T11:11:11+00:00")
                .expect("Failed to parse datetime")
                .with_timezone(&Utc),
            MonthlyUsageAttributionSupportedMetrics::INFRA_HOST_USAGE,
            GetMonthlyUsageAttributionOptionalParams::default(),
        )
        .await;
    if let Ok(value) = resp {
        println!("{:#?}", value);
    } else {
        println!("{:#?}", resp.unwrap_err());
    }
}
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=rust) and then save the example to `src/main.rs` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" cargo run
##### 

```typescript
/**
 * Get monthly usage attribution returns "OK" response
 */

import { client, v1 } from "@datadog/datadog-api-client";

const configuration = client.createConfiguration();
const apiInstance = new v1.UsageMeteringApi(configuration);

const params: v1.UsageMeteringApiGetMonthlyUsageAttributionRequest = {
  startMonth: new Date(new Date().getTime() + -3 * 86400 * 1000),
  fields: "infra_host_usage",
};

apiInstance
  .getMonthlyUsageAttribution(params)
  .then((data: v1.MonthlyUsageAttributionResponse) => {
    console.log(
      "API called successfully. Returned data: " + JSON.stringify(data)
    );
  })
  .catch((error: any) => console.error(error));
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=typescript) and then save the example to `example.ts` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" tsc "example.ts"
{% /tab %}
